<script>
  import {baseUrl} from './../../config'
  
  export default {
    props: ['lat', 'lng', 'zoomLevel'],

    created () {
      if (this.lat != null && this.lng != null) {
        this.location.lat = parseFloat(this.lat);
        this.location.lng = parseFloat(this.lng);
      }

      if (this.zoomLevel != null) {
        this.zoom = parseInt(this.zoomLevel);
      }
    },

    data () {
      return {
        zoom: 10,
        location: {
          lat: 29.9285,
          lng: 30.9188
        },
        markers: [{
          position: {lat: 10.0, lng: 10.0}
        }],

        url: baseUrl + "/images/marker.png",

        styles: [{"featureType":"water","elementType":"geometry","stylers":[{"color":"#e9e9e9"},{"lightness":17}]},{"featureType":"landscape","elementType":"geometry","stylers":[{"color":"#f5f5f5"},{"lightness":20}]},{"featureType":"road.highway","elementType":"geometry.fill","stylers":[{"color":"#ffffff"},{"lightness":17}]},{"featureType":"road.highway","elementType":"geometry.stroke","stylers":[{"color":"#ffffff"},{"lightness":29},{"weight":0.2}]},{"featureType":"road.arterial","elementType":"geometry","stylers":[{"color":"#ffffff"},{"lightness":18}]},{"featureType":"road.local","elementType":"geometry","stylers":[{"color":"#ffffff"},{"lightness":16}]},{"featureType":"poi","elementType":"geometry","stylers":[{"color":"#f5f5f5"},{"lightness":21}]},{"featureType":"poi.park","elementType":"geometry","stylers":[{"color":"#dedede"},{"lightness":21}]},{"elementType":"labels.text.stroke","stylers":[{"visibility":"on"},{"color":"#ffffff"},{"lightness":16}]},{"elementType":"labels.text.fill","stylers":[{"saturation":36},{"color":"#333333"},{"lightness":40}]},{"elementType":"labels.icon","stylers":[{"visibility":"off"}]},{"featureType":"transit","elementType":"geometry","stylers":[{"color":"#f2f2f2"},{"lightness":19}]},{"featureType":"administrative","elementType":"geometry.fill","stylers":[{"color":"#fefefe"},{"lightness":20}]},{"featureType":"administrative","elementType":"geometry.stroke","stylers":[{"color":"#fefefe"},{"lightness":17},{"weight":1.2}]}]
      
      }
    },

    methods: {
      setPlace (place) {
        this.location = {
          lat: place.geometry.location.lat(),
          lng: place.geometry.location.lng()
        }
      },

      markerDrag (position) {
        this.location = {
          lat: position.lat(),
          lng: position.lng()
        }
      }
    }
  }
</script>

<template>
  <div class="MapLocation__wrapper">
    <label for="location">الموقع على الخريطة</label>
    <div id="location">
      <gmap-autocomplete @place_changed="setPlace" class="search-box form-control"></gmap-autocomplete>
      <gmap-map
        :center="location"
        :zoom=this.zoom
        :options="{styles: styles}"
        style="width: 100%; height: 300px">
        <gmap-marker
          :position="location"
          :clickable="true"
          :draggable="true"
          :icon="{url: url}"
          @click="center=location"
          @place_changed="setPlace"
          @position_changed="markerDrag($event)"
        ></gmap-marker>
      </gmap-map>
    </div>

    <input type="hidden" v-model="location.lat" name="lat">
    <input type="hidden" v-model="location.lng" name="lng">
  </div>
</template>

<style>
  .search-box {
    width: 100%;
    margin-bottom: 1rem;
  }
</style>
